// TASK 06

package task06;

import java.util.Stack;

// The method eval evaluates a given arithmetic expression in
// postfix notation. The following characters are used:

// 't': this character represents the boolean value true
// 'f': this character represents the boolean value false
// 'e': this character represents equality of boolean values
// 'n': this character represents negation

// Example:
// Consider the following boolean expression in postfix notation:
// char [] exp = {'t', 'f', 'e', 'n'};
// 
// This expression corresponds to the following boolean expression:
// NOT ( TRUE == FALSE )
//
// Therefore, eval(exp) should return the boolean value true.

public class Eval {

	public static boolean eval(char[] expression) {

		// place your code here
		Stack<Boolean> intermediate = new Stack<Boolean>();

		for (char next : expression) {
			switch (next) {
			case 'f': {
				intermediate.push(false);
				break;
			}
			case 't': {
				intermediate.push(true);
				break;
			}
			case 'e': {
				boolean op1 = intermediate.pop();
				boolean op2 = intermediate.pop();
				intermediate.push(op1 == op2);
				break;
			}
			case 'n': {
				intermediate.push(!intermediate.pop());
				break;
			}
			default:
				throw new IllegalArgumentException();
			}
		}
		if (intermediate.size() == 1) {
			return intermediate.pop();
		} else
			throw new IllegalArgumentException();
	}
}
